# kutils Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KReplace Class Reference

A generic implementation of the "replace" function. More...

`#include <kreplace.h>`

Inheritance diagram for KReplace:

[legend]
Collaboration diagram for KReplace:

[legend]
List of all members.

## Signals

void | replace (const QString &text, int replacementIndex, int replacedLength, int matchedLength)
| Connect to this slot to implement updating of replaced text during the replace operation.

## Public Member Functions

| KReplace (const QString &pattern, const QString &replacement, long options, QWidget *parent=0)
| Will create a prompt dialog and use it as needed.
int | numReplacements () const
| Return the number of replacements made (i.e.
virtual void | resetCounts ()
| Call this to reset the numMatches & numReplacements counts.
Result | replace ()
| Walk the text fragment (e.g.
KDialogBase * | replaceNextDialog (bool create=false)
| Return (or create) the dialog that shows the "find next?" prompt.
void | closeReplaceNextDialog ()
| Close the "replace next?" dialog.
virtual bool | shouldRestart (bool forceAsking=false, bool showNumMatches=true) const
| Returns true if we should restart the search from scratch.
virtual void | displayFinalDialog () const
| Displays the final dialog telling the user how many replacements were made.

## Static Public Member Functions

int | replace (QString &text, const QString &pattern, const QString &replacement, int index, long options, int *replacedLength)
| Search the given string, replaces with the given replacement string, and returns whether a match was found.
int | replace (QString &text, const QRegExp &pattern, const QString &replacement, int index, long options, int *replacedLength)

## Protected Slots

void | slotSkip ()
void | slotReplace ()
void | slotReplaceAll ()

## Detailed Description

A generic implementation of the "replace" function.

Author:
  S.R.Haque <srhaque@iee.org>, David Faure <faure@kde.org>

Detail

This class includes prompt handling etc. Also provides some static functions which can be used to create custom behaviour instead of using the class directly.

Example

To use the class to implement a complete replace feature:

In the slot connect to the replace action, after using KReplaceDialog:

      // This creates a replace-on-prompt dialog if needed.
      m_replace = new KReplace(pattern, replacement, options);

      // Connect signals to code which handles highlighting
      // of found text, and on-the-fly replacement.
      connect( m_replace, SIGNAL( highlight( const QString &, int, int ) ),
              this, SLOT( slotHighlight( const QString &, int, int ) ) );
      // Connect findNext signal - called when pressing the button in the dialog
      connect( m_replace, SIGNAL( findNext() ),
              this, SLOT( slotReplaceNext() ) );
      // Connect replace signal - called when doing a replacement
      connect( m_replace, SIGNAL( replace(const QString &, int, int, int) ),
              this, SLOT( slotReplace(const QString &, int, int, int) ) );

      Then initialize the variables determining the "current position"
      (to the cursor, if the option FromCursor is set,
       to the beginning of the selection if the option SelectedText is set,
       and to the beginning of the document otherwise).
      Initialize the "end of search" variables as well (end of doc or end of selection).
      Swap begin and end if FindBackwards.
      Finally, call slotReplaceNext();

      void slotReplaceNext()
      {
          KFind::Result res = KFind::NoMatch;
          while ( res == KFind::NoMatch &&  ) {
              if ( m_replace->needData() )
                  m_replace->setData( <current text fragment> );

              // Let KReplace inspect the text fragment, and display a dialog if a match is found
              res = m_replace->res();

              if ( res == KFind::NoMatch ) {
                  <Move to the next non-empty text fragment, honouring the FindBackwards setting for the direction>
              }
          }

          if ( res == KFind::NoMatch ) // i.e. at end
              <Call either  m_replace->displayFinalDialog(); delete m_replace; m_replace = 0L;
               or           if ( m_replace->shouldRestart() ) { reinit and call slotReplaceNext(); }
                            else { delete m_replace; m_replace = 0L; }>
      }

     Don't forget delete m_find in the destructor of your class,
     unless you gave it a parent widget on construction.

Definition at line 96 of file kreplace.h.

## Constructor & Destructor Documentation

KReplace::KReplace | ( | const QString & | pattern,
|  | const QString & | replacement,
|  | long | options,
|  | QWidget * | parent = 0
| ) |

| Will create a prompt dialog and use it as needed. Definition at line 63 of file kreplace.cpp.

## Member Function Documentation

int KReplace::numReplacements | ( |  | ) | const`[inline]`

| Return the number of replacements made (i.e. the number of times the replace signal was emitted). Can be used in a dialog box to tell the user how many replacements were made. The final dialog does so already, unless you used setDisplayFinalDialog(false). Definition at line 113 of file kreplace.h.

void KReplace::resetCounts | ( |  | ) | `[virtual]`

| Call this to reset the numMatches & numReplacements counts. Can be useful if reusing the same KReplace for different operations, or when restarting from the beginning of the document. Reimplemented from KFind. Definition at line 273 of file kreplace.cpp. References KFind::resetCounts().

KFind::Result KReplace::replace | ( |  | ) |

| Walk the text fragment (e.g. kwrite line, kspread cell) looking for matches. For each match, if prompt-on-replace is specified, emits the highlight() signal and displays the prompt-for-replace dialog before doing the replace. Definition at line 103 of file kreplace.cpp. References KFind::find(), KFind::highlight(), and KFind::validateMatch(). Referenced by replace().

KDialogBase * KReplace::replaceNextDialog | ( | bool | create = false | ) |

| Return (or create) the dialog that shows the "find next?" prompt. Usually you don't need to call this. One case where it can be useful, is when the user selects the "Find" menu item while a find operation is under way. In that case, the program may want to call setActiveWindow() on that dialog. Definition at line 75 of file kreplace.cpp. References KStdAction::create().

void KReplace::closeReplaceNextDialog | ( |  | ) |

| Close the "replace next?" dialog. The application should do this when the last match was hit. If the application deletes the KReplace, then "find previous" won't be possible anymore. Definition at line 303 of file kreplace.cpp. References KFind::closeFindNextDialog().

int KReplace::replace | ( | QString & | text,
|  | const QString & | pattern,
|  | const QString & | replacement,
|  | int | index,
|  | long | options,
|  | int * | replacedLength
| ) | `[static]`

Search the given string, replaces with the given replacement string, and returns whether a match was found.

If one is, the replacement string length is also returned.

A performance optimised version of the function is provided for use with regular expressions.

Parameters:

  text | The string to search.
  pattern | The pattern to look for.
  replacement | The replacement string to insert into the text.
  index | The starting index into the string.
  options | The options to use.
  replacedLength | Output parameter, contains the length of the replaced string. Not always the same as replacement.length(), when backreferences are used.

Returns:
  The index at which a match was found, or -1 if no match was found.

Definition at line 180 of file kreplace.cpp.

References KFind::find(), and replace().

bool KReplace::shouldRestart | ( | bool | forceAsking = false,
|  | bool | showNumMatches = true
| ) | const`[virtual]`

Returns true if we should restart the search from scratch.

Can ask the user, or return false (if we already searched/replaced the whole document without the PromptOnReplace option).

Parameters:

  forceAsking | set to true if the user modified the document during the search. In that case it makes sense to restart the search again.
  showNumMatches | set to true if the dialog should show the number of matches. Set to false if the application provides a "find previous" action, in which case the match count will be erroneous when hitting the end, and we could even be hitting the beginning of the document (so not all matches have even been seen).

Reimplemented from KFind.

Definition at line 279 of file kreplace.cpp.

References displayFinalDialog(), and KMessageBox::questionYesNo().

void KReplace::displayFinalDialog | ( |  | ) | const`[virtual]`

| Displays the final dialog telling the user how many replacements were made. Call either this or shouldRestart(). Reimplemented from KFind. Definition at line 95 of file kreplace.cpp. References KMessageBox::information(). Referenced by shouldRestart().

void KReplace::replace | ( | const QString & | text,
|  | int | replacementIndex,
|  | int | replacedLength,
|  | int | matchedLength
| ) | `[signal]`

Connect to this slot to implement updating of replaced text during the replace operation.

Extra care must be taken to properly implement the "no prompt-on-replace" case. For instance highlight isn't emitted in that case (some code might rely on it), and for performance reasons one should repaint after replace() ONLY if prompt-on-replace was selected.

Parameters:

  text | The text, in which the replacement has already been done.
  replacementIndex | Starting index of the matched substring
  replacedLength | Length of the replacement string
  matchedLength | Length of the matched string

The documentation for this class was generated from the following files:

- kreplace.h
- kreplace.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:28:09 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001